#include <iostream>
#define _USE_MATH_DEFINES
#include <math.h>

struct LinkLength
{
  double l0;
  double l1;
};
struct Position
{
  double x;
  double y;
};
struct JointAngle
{
  double th0;
  double th1;
};

JointAngle invkinem(LinkLength link, Position pos)
{
  double ld(sqrt((pos.x * pos.x) + (pos.y * pos.y)));
  double l1(link.l0);
  double l2(link.l1);

  double a  = acos((pow(l1, 2) + pow(ld, 2) - pow(l2, 2)) / (2 * l1 * ld));
  double b  = acos((pow(l1, 2) + pow(l2, 2) - pow(ld, 2)) / (2 * l1 * l2));
  double phi = atan2(pos.y, pos.x);

  JointAngle j;
  j.th0 = - ((M_PI / 2) - a - phi) * 180 / M_PI;
  j.th1 = - ( M_PI - b) * 180 / M_PI;

  return j;
}

JointAngle invkinem2(LinkLength link, Position pos)
{
  double ld(sqrt((pos.x * pos.x) + (pos.y * pos.y)));
  double l1(link.l0);
  double l2(link.l1);

  double a  = acos((pow(l1, 2) + pow(ld, 2) - pow(l2, 2)) / (2 * l1 * ld));
  double b  = acos((pow(l1, 2) + pow(l2, 2) - pow(ld, 2)) / (2 * l1 * l2));
  double phi = atan2(pos.y, pos.x);

  JointAngle j;
  j.th0 = - ((M_PI / 2) + a - phi) * 180 / M_PI;
  j.th1 = - (-M_PI + b) * 180 / M_PI;

  return j;
}

int main(void)
{
  LinkLength l = {1.0, 1.0};
  Position pos[] = {
    {-1.0, 1.0},
    {-0.5, 1.0},
    { 0.0, 1.0},
    { 0.5, 1.0},
    { 1.0, 1.0},
  };

  for (int i(0); i < 5; ++i)
    {
      JointAngle j = invkinem(l, pos[i]);
      std::cout << "pos (x, y): " << pos[i].x << ", " << pos[i].y << "\t ==> ";
      std::cout << "angle (th0, th1): " << j.th0 << ", " << j.th1 << std::endl;
    }

  return 0;
}
